gnt-group: Add hv/disk state to add
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN = $(top_srcdir)/autotools/check-man
26 CHECK_VERSION = $(top_srcdir)/autotools/check-version
27 CHECK_NEWS = $(top_srcdir)/autotools/check-news
28 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
29 DOCPP = $(top_srcdir)/autotools/docpp
30 REPLACE_VARS_SED = autotools/replace_vars.sed
31 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
32 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
33
34 # Note: these are automake-specific variables, and must be named after
35 # the directory + 'dir' suffix
36 clientdir = $(pkgpythondir)/client
37 hypervisordir = $(pkgpythondir)/hypervisor
38 httpdir = $(pkgpythondir)/http
39 masterddir = $(pkgpythondir)/masterd
40 confddir = $(pkgpythondir)/confd
41 rapidir = $(pkgpythondir)/rapi
42 serverdir = $(pkgpythondir)/server
43 watcherdir = $(pkgpythondir)/watcher
44 impexpddir = $(pkgpythondir)/impexpd
45 utilsdir = $(pkgpythondir)/utils
46 toolsdir = $(pkglibdir)/tools
47 iallocatorsdir = $(pkglibdir)/iallocators
48 pytoolsdir = $(pkgpythondir)/tools
49 docdir = $(datadir)/doc/$(PACKAGE)
50
51 # Delete output file if an error occurred while building it
52 .DELETE_ON_ERROR:
53
54 HTOOLS_DIRS = \
55         htools \
56         htools/Ganeti \
57         htools/Ganeti/HTools \
58         htools/Ganeti/HTools/Program
59
60 DIRS = \
61         autotools \
62         daemons \
63         devel \
64         doc \
65         doc/examples \
66         doc/examples/hooks \
67         doc/examples/gnt-debug \
68         $(HTOOLS_DIRS) \
69         lib \
70         lib/client \
71         lib/build \
72         lib/confd \
73         lib/http \
74         lib/hypervisor \
75         lib/impexpd \
76         lib/masterd \
77         lib/rapi \
78         lib/server \
79         lib/tools \
80         lib/utils \
81         lib/watcher \
82         man \
83         qa \
84         test \
85         test/data \
86         test/data/ovfdata \
87         test/data/ovfdata/other \
88         tools
89
90 BUILDTIME_DIR_AUTOCREATE = \
91         scripts \
92         $(APIDOC_DIR) \
93         $(APIDOC_PY_DIR) \
94         $(APIDOC_HS_DIR) \
95         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
96         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
97         $(COVERAGE_DIR) \
98         $(COVERAGE_PY_DIR) \
99         $(COVERAGE_HS_DIR) \
100         .hpc
101
102 BUILDTIME_DIRS = \
103         $(BUILDTIME_DIR_AUTOCREATE) \
104         doc/html
105
106 DIRCHECK_EXCLUDE = \
107         $(BUILDTIME_DIRS) \
108         ganeti-[0-9]*.[0-9]*.[0-9]* \
109         doc/html/_*
110
111 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
112
113 # some helper vars
114 COVERAGE_DIR = doc/coverage
115 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
116 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
117 APIDOC_DIR = doc/api
118 APIDOC_PY_DIR = $(APIDOC_DIR)/py
119 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
120
121 MAINTAINERCLEANFILES = \
122         $(docpng) \
123         $(maninput) \
124         doc/install-quick.rst \
125         doc/news.rst \
126         doc/upgrade.rst \
127         vcs-version
128
129 maintainer-clean-local:
130         rm -rf $(BUILDTIME_DIRS)
131
132 CLEANFILES = \
133         $(addsuffix /*.py[co],$(DIRS)) \
134         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
135         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
136         $(all_dirfiles) \
137         $(PYTHON_BOOTSTRAP) \
138         epydoc.conf \
139         autotools/replace_vars.sed \
140         daemons/daemon-util \
141         daemons/ganeti-cleaner \
142         devel/upload \
143         $(BUILT_EXAMPLES) \
144         doc/examples/bash_completion \
145         lib/_generated_rpc.py \
146         $(man_MANS) \
147         $(manhtml) \
148         tools/kvm-ifup \
149         stamp-srclinks \
150         $(nodist_pkgpython_PYTHON) \
151         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
152         .hpc/*.mix htools/*.tix \
153         doc/hs-lint.html
154
155 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
156 # it'll cause the target to rebuild every time.
157 BUILT_SOURCES = \
158         ganeti \
159         stamp-srclinks \
160         $(all_dirfiles) \
161         $(PYTHON_BOOTSTRAP) \
162         $(BUILT_PYTHON_SOURCES)
163
164 BUILT_PYTHON_SOURCES = \
165         lib/_autoconf.py \
166         lib/_vcsversion.py \
167         lib/_generated_rpc.py
168
169 # these are all built from the underlying %.in sources
170 BUILT_EXAMPLES = \
171         doc/examples/ganeti-kvm-poweroff.initd \
172         doc/examples/ganeti.cron \
173         doc/examples/ganeti.initd \
174         doc/examples/gnt-config-backup \
175         doc/examples/hooks/ipsec
176
177 nodist_pkgpython_PYTHON = \
178         $(BUILT_PYTHON_SOURCES)
179
180 noinst_PYTHON = \
181         lib/build/__init__.py \
182         lib/build/sphinx_ext.py
183
184 pkgpython_PYTHON = \
185         lib/__init__.py \
186         lib/asyncnotifier.py \
187         lib/backend.py \
188         lib/bdev.py \
189         lib/bootstrap.py \
190         lib/cli.py \
191         lib/cmdlib.py \
192         lib/compat.py \
193         lib/config.py \
194         lib/constants.py \
195         lib/daemon.py \
196         lib/errors.py \
197         lib/ht.py \
198         lib/jqueue.py \
199         lib/jstore.py \
200         lib/locking.py \
201         lib/luxi.py \
202         lib/mcpu.py \
203         lib/netutils.py \
204         lib/objects.py \
205         lib/opcodes.py \
206         lib/ovf.py \
207         lib/qlang.py \
208         lib/query.py \
209         lib/rpc.py \
210         lib/rpc_defs.py \
211         lib/runtime.py \
212         lib/serializer.py \
213         lib/ssconf.py \
214         lib/ssh.py \
215         lib/storage.py \
216         lib/uidpool.py \
217         lib/workerpool.py
218
219 client_PYTHON = \
220         lib/client/__init__.py \
221         lib/client/gnt_backup.py \
222         lib/client/gnt_cluster.py \
223         lib/client/gnt_debug.py \
224         lib/client/gnt_group.py \
225         lib/client/gnt_instance.py \
226         lib/client/gnt_job.py \
227         lib/client/gnt_node.py \
228         lib/client/gnt_os.py
229
230 hypervisor_PYTHON = \
231         lib/hypervisor/__init__.py \
232         lib/hypervisor/hv_base.py \
233         lib/hypervisor/hv_chroot.py \
234         lib/hypervisor/hv_fake.py \
235         lib/hypervisor/hv_kvm.py \
236         lib/hypervisor/hv_lxc.py \
237         lib/hypervisor/hv_xen.py
238
239 rapi_PYTHON = \
240         lib/rapi/__init__.py \
241         lib/rapi/baserlib.py \
242         lib/rapi/client.py \
243         lib/rapi/client_utils.py \
244         lib/rapi/connector.py \
245         lib/rapi/rlib2.py
246
247 http_PYTHON = \
248         lib/http/__init__.py \
249         lib/http/auth.py \
250         lib/http/client.py \
251         lib/http/server.py
252
253 confd_PYTHON = \
254         lib/confd/__init__.py \
255         lib/confd/client.py \
256         lib/confd/querylib.py \
257         lib/confd/server.py
258
259 masterd_PYTHON = \
260         lib/masterd/__init__.py \
261         lib/masterd/instance.py
262
263 impexpd_PYTHON = \
264         lib/impexpd/__init__.py
265
266 watcher_PYTHON = \
267         lib/watcher/__init__.py \
268         lib/watcher/nodemaint.py \
269         lib/watcher/state.py
270
271 server_PYTHON = \
272         lib/server/__init__.py \
273         lib/server/confd.py \
274         lib/server/masterd.py \
275         lib/server/noded.py \
276         lib/server/rapi.py
277
278 pytools_PYTHON = \
279         lib/tools/__init__.py \
280         lib/tools/ensure_dirs.py
281
282 utils_PYTHON = \
283         lib/utils/__init__.py \
284         lib/utils/algo.py \
285         lib/utils/filelock.py \
286         lib/utils/hash.py \
287         lib/utils/io.py \
288         lib/utils/log.py \
289         lib/utils/mlock.py \
290         lib/utils/nodesetup.py \
291         lib/utils/process.py \
292         lib/utils/retry.py \
293         lib/utils/text.py \
294         lib/utils/wrapper.py \
295         lib/utils/x509.py
296
297 docrst = \
298         doc/admin.rst \
299         doc/design-2.0.rst \
300         doc/design-2.1.rst \
301         doc/design-2.2.rst \
302         doc/design-2.3.rst \
303         doc/design-htools-2.3.rst \
304         doc/design-2.4.rst \
305         doc/design-2.5.rst \
306         doc/design-draft.rst \
307         doc/design-oob.rst \
308         doc/design-cpu-pinning.rst \
309         doc/design-query2.rst \
310         doc/design-x509-ca.rst \
311         doc/design-http-server.rst \
312         doc/design-impexp2.rst \
313         doc/design-lu-generated-jobs.rst \
314         doc/design-multi-reloc.rst \
315         doc/design-network.rst \
316         doc/design-chained-jobs.rst \
317         doc/design-ovf-support.rst \
318         doc/design-resource-model.rst \
319         doc/cluster-merge.rst \
320         doc/design-shared-storage.rst \
321         doc/design-node-state-cache.rst \
322         doc/design-virtual-clusters.rst \
323         doc/devnotes.rst \
324         doc/glossary.rst \
325         doc/hooks.rst \
326         doc/iallocator.rst \
327         doc/index.rst \
328         doc/install-quick.rst \
329         doc/install.rst \
330         doc/locking.rst \
331         doc/move-instance.rst \
332         doc/news.rst \
333         doc/rapi.rst \
334         doc/security.rst \
335         doc/upgrade.rst \
336         doc/walkthrough.rst
337
338 HS_PROGS = htools/htools
339 HS_BIN_ROLES = hbal hscan hspace
340
341 HS_ALL_PROGS = $(HS_PROGS) htools/test
342 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
343 # we don't add -Werror by default
344 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
345 # extra flags that can be overriden on the command line
346 HEXTRA =
347 # exclude options for coverage reports
348 HPCEXCL = --exclude Main \
349         --exclude Ganeti.Constants \
350         --exclude Ganeti.THH \
351         --exclude Ganeti.HTools.QC \
352         --exclude Ganeti.HTools.QCHelper \
353         --exclude Ganeti.HTools.Version
354
355 HS_LIB_SRCS = \
356         htools/Ganeti/HTools/CLI.hs \
357         htools/Ganeti/HTools/Cluster.hs \
358         htools/Ganeti/HTools/Compat.hs \
359         htools/Ganeti/HTools/Container.hs \
360         htools/Ganeti/HTools/ExtLoader.hs \
361         htools/Ganeti/HTools/Group.hs \
362         htools/Ganeti/HTools/IAlloc.hs \
363         htools/Ganeti/HTools/Instance.hs \
364         htools/Ganeti/HTools/JSON.hs \
365         htools/Ganeti/HTools/Loader.hs \
366         htools/Ganeti/HTools/Luxi.hs \
367         htools/Ganeti/HTools/Node.hs \
368         htools/Ganeti/HTools/PeerMap.hs \
369         htools/Ganeti/HTools/QC.hs \
370         htools/Ganeti/HTools/QCHelper.hs \
371         htools/Ganeti/HTools/Rapi.hs \
372         htools/Ganeti/HTools/Simu.hs \
373         htools/Ganeti/HTools/Text.hs \
374         htools/Ganeti/HTools/Types.hs \
375         htools/Ganeti/HTools/Utils.hs \
376         htools/Ganeti/HTools/Program/Hail.hs \
377         htools/Ganeti/HTools/Program/Hbal.hs \
378         htools/Ganeti/HTools/Program/Hscan.hs \
379         htools/Ganeti/HTools/Program/Hspace.hs \
380         htools/Ganeti/Jobs.hs \
381         htools/Ganeti/Luxi.hs \
382         htools/Ganeti/OpCodes.hs \
383         htools/Ganeti/THH.hs
384
385 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
386 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
387
388 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
389
390 # Note: we use here an order-only prerequisite, as the contents of
391 # _autoconf.py are not actually influencing the html build output: it
392 # has to exist in order for the sphinx module to be loaded
393 # successfully, but we certainly don't want the docs to be rebuilt if
394 # it changes
395 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
396         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
397         | $(BUILT_PYTHON_SOURCES)
398         @test -n "$(SPHINX)" || \
399             { echo 'sphinx-build' not found during configure; exit 1; }
400         @mkdir_p@ $(dir $@)
401         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
402             -d . \
403             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
404             -D release="$(PACKAGE_VERSION)" \
405             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
406         rm -f doc/html/.buildinfo doc/html/objects.inv
407         touch $@
408
409 doc/html: doc/html/index.html
410
411 doc/install-quick.rst: INSTALL
412 doc/news.rst: NEWS
413 doc/upgrade.rst: UPGRADE
414
415 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
416         set -e; \
417         { echo '.. This file is automatically updated at build time from $<.'; \
418           echo '.. Do not edit.'; \
419           echo; \
420           cat $<; \
421         } > $@
422
423 docdot = \
424         doc/arch-2.0.dot \
425         doc/design-2.1-lock-acquire.dot \
426         doc/design-2.1-lock-release.dot
427
428 docpng = $(patsubst %.dot,%.png,$(docdot))
429
430 # Things to build but not to install (add it to EXTRA_DIST if it should be
431 # distributed)
432 noinst_DATA = \
433         devel/upload \
434         doc/html \
435         $(BUILT_EXAMPLES) \
436         doc/examples/bash_completion \
437         $(manhtml)
438
439 gnt_scripts = \
440         scripts/gnt-backup \
441         scripts/gnt-cluster \
442         scripts/gnt-debug \
443         scripts/gnt-group \
444         scripts/gnt-instance \
445         scripts/gnt-job \
446         scripts/gnt-node \
447         scripts/gnt-os
448
449 PYTHON_BOOTSTRAP_SBIN = \
450         daemons/ganeti-confd \
451         daemons/ganeti-masterd \
452         daemons/ganeti-noded \
453         daemons/ganeti-watcher \
454         daemons/ganeti-rapi \
455         $(gnt_scripts)
456
457 PYTHON_BOOTSTRAP = \
458         $(PYTHON_BOOTSTRAP_SBIN) \
459         tools/ensure-dirs
460
461 qa_scripts = \
462         qa/ganeti-qa.py \
463         qa/qa_cluster.py \
464         qa/qa_config.py \
465         qa/qa_daemon.py \
466         qa/qa_env.py \
467         qa/qa_error.py \
468         qa/qa_group.py \
469         qa/qa_instance.py \
470         qa/qa_node.py \
471         qa/qa_os.py \
472         qa/qa_rapi.py \
473         qa/qa_tags.py \
474         qa/qa_utils.py
475
476 bin_SCRIPTS =
477 if WANT_HTOOLS
478 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
479 install-exec-hook:
480         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
481 # FIXME: this is a hardcoded logic, instead of auto-resolving
482         $(LN_S) -f ../../../bin/htools \
483                    $(DESTDIR)$(iallocatorsdir)/hail
484         for role in $(HS_BIN_ROLES); do \
485                 $(LN_S) -f htools \
486                            $(DESTDIR)$(bindir)/$$role ; \
487         done
488 endif
489
490 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
491         @if [ -z "$(HTOOLS)" ]; then \
492           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
493           exit 1; \
494         fi
495         @BINARY=$(@:htools/%=%); \
496         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
497           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
498           exit 1; \
499         fi
500         BINARY=$(@:htools/%=%); $(GHC) --make \
501           $(HFLAGS) \
502           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
503           -osuf $$BINARY.o -hisuf $$BINARY.hi \
504           $(HEXTRA) $@
505
506 # for the htools/test binary, we need to enable profiling/coverage
507 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
508         -fno-warn-monomorphism-restriction -fno-warn-orphans \
509         -fno-warn-missing-methods -fno-warn-unused-imports
510
511 dist_sbin_SCRIPTS = \
512         tools/ganeti-listrunner
513
514 nodist_sbin_SCRIPTS = \
515         $(PYTHON_BOOTSTRAP_SBIN) \
516         daemons/ganeti-cleaner
517
518 python_scripts = \
519         tools/burnin \
520         tools/cfgshell \
521         tools/cfgupgrade \
522         tools/cfgupgrade12 \
523         tools/cluster-merge \
524         tools/confd-client \
525         tools/lvmstrap \
526         tools/move-instance \
527         tools/ovfconverter \
528         tools/setup-ssh \
529         tools/sanitize-config
530
531 dist_tools_SCRIPTS = \
532         $(python_scripts) \
533         tools/kvm-console-wrapper \
534         tools/xm-console-wrapper \
535         tools/master-ip-setup
536
537 pkglib_python_scripts = \
538         daemons/import-export \
539         tools/check-cert-expired
540
541 nodist_pkglib_python_scripts = \
542         tools/ensure-dirs
543
544 pkglib_SCRIPTS = \
545         daemons/daemon-util \
546         tools/kvm-ifup \
547         $(pkglib_python_scripts)
548
549 nodist_pkglib_SCRIPTS = \
550         $(nodist_pkglib_python_scripts)
551
552 EXTRA_DIST = \
553         NEWS \
554         UPGRADE \
555         epydoc.conf.in \
556         pylintrc \
557         autotools/build-bash-completion \
558         autotools/build-rpc \
559         autotools/check-header \
560         autotools/check-python-code \
561         autotools/check-imports \
562         autotools/check-man \
563         autotools/check-news \
564         autotools/check-tar \
565         autotools/check-version \
566         autotools/convert-constants \
567         autotools/docpp \
568         autotools/gen-coverage \
569         autotools/testrunner \
570         $(RUN_IN_TEMPDIR) \
571         daemons/daemon-util.in \
572         daemons/ganeti-cleaner.in \
573         $(pkglib_python_scripts) \
574         devel/upload.in \
575         tools/kvm-ifup.in \
576         $(docdot) \
577         $(docpng) \
578         $(docrst) \
579         doc/conf.py \
580         doc/html \
581         $(BUILT_EXAMPLES:%=%.in) \
582         doc/examples/ganeti.default \
583         doc/examples/ganeti.default-debug \
584         doc/examples/hooks/ethers \
585         doc/examples/gnt-debug/README \
586         doc/examples/gnt-debug/delay0.json \
587         doc/examples/gnt-debug/delay50.json \
588         test/testutils.py \
589         test/mocks.py \
590         $(dist_TESTS) \
591         $(TEST_FILES) \
592         man/footer.rst \
593         $(manrst) \
594         $(maninput) \
595         qa/qa-sample.json \
596         $(qa_scripts) \
597         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
598         $(HS_PROG_SRCS) \
599         htools/lint-hints.hs
600
601 man_MANS = \
602         man/ganeti.7 \
603         man/ganeti-cleaner.8 \
604         man/ganeti-confd.8 \
605         man/ganeti-listrunner.8 \
606         man/ganeti-masterd.8 \
607         man/ganeti-noded.8 \
608         man/ganeti-os-interface.7 \
609         man/ganeti-rapi.8 \
610         man/ganeti-watcher.8 \
611         man/gnt-backup.8 \
612         man/gnt-cluster.8 \
613         man/gnt-debug.8 \
614         man/gnt-group.8 \
615         man/gnt-instance.8 \
616         man/gnt-job.8 \
617         man/gnt-node.8 \
618         man/gnt-os.8 \
619         man/hail.1 \
620         man/hbal.1 \
621         man/hscan.1 \
622         man/hspace.1 \
623         man/htools.1
624
625 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
626 manhtml = $(patsubst %.rst,%.html,$(manrst))
627 mangen = $(patsubst %.rst,%.gen,$(manrst))
628 maninput = \
629         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
630         $(patsubst %.html,%.html.in,$(manhtml)) \
631         man/footer.man man/footer.html $(mangen)
632
633 TEST_FILES = \
634         test/data/bdev-drbd-8.0.txt \
635         test/data/bdev-drbd-8.3.txt \
636         test/data/bdev-drbd-disk.txt \
637         test/data/bdev-drbd-net-ip4.txt \
638         test/data/bdev-drbd-net-ip6.txt \
639         test/data/cert1.pem \
640         test/data/ip-addr-show-dummy0.txt \
641         test/data/ip-addr-show-lo-ipv4.txt \
642         test/data/ip-addr-show-lo-ipv6.txt \
643         test/data/ip-addr-show-lo-oneline-ipv4.txt \
644         test/data/ip-addr-show-lo-oneline-ipv6.txt \
645         test/data/ip-addr-show-lo-oneline.txt \
646         test/data/ip-addr-show-lo.txt \
647         test/data/proc_drbd8.txt \
648         test/data/proc_drbd80-emptyline.txt \
649         test/data/proc_drbd83.txt \
650         test/data/proc_drbd83_sync.txt \
651         test/data/proc_drbd83_sync_krnl2.6.39.txt \
652         test/data/sys_drbd_usermode_helper.txt \
653         test/data/ovfdata/compr_disk.vmdk.gz \
654         test/data/ovfdata/config.ini \
655         test/data/ovfdata/corrupted_resources.ovf \
656         test/data/ovfdata/empty.ini \
657         test/data/ovfdata/empty.ovf \
658         test/data/ovfdata/ganeti.mf \
659         test/data/ovfdata/ganeti.ovf \
660         test/data/ovfdata/gzip_disk.ovf \
661         test/data/ovfdata/new_disk.vmdk \
662         test/data/ovfdata/no_disk.ini \
663         test/data/ovfdata/no_disk_in_ref.ovf \
664         test/data/ovfdata/no_os.ini \
665         test/data/ovfdata/no_ovf.ova \
666         test/data/ovfdata/ova.ova \
667         test/data/ovfdata/second_disk.vmdk \
668         test/data/ovfdata/rawdisk.raw \
669         test/data/ovfdata/unsafe_path.ini \
670         test/data/ovfdata/virtualbox.ovf \
671         test/data/ovfdata/wrong_extension.ovd \
672         test/data/ovfdata/wrong_config.ini \
673         test/data/ovfdata/wrong_manifest.mf \
674         test/data/ovfdata/wrong_manifest.ovf \
675         test/data/ovfdata/wrong_ova.ova \
676         test/data/ovfdata/wrong_xml.ovf \
677         test/data/ovfdata/other/rawdisk.raw \
678         test/import-export_unittest-helper
679
680 python_tests = \
681         test/ganeti.asyncnotifier_unittest.py \
682         test/ganeti.backend_unittest.py \
683         test/ganeti.bdev_unittest.py \
684         test/ganeti.cli_unittest.py \
685         test/ganeti.client.gnt_cluster_unittest.py \
686         test/ganeti.client.gnt_instance_unittest.py \
687         test/ganeti.daemon_unittest.py \
688         test/ganeti.cmdlib_unittest.py \
689         test/ganeti.compat_unittest.py \
690         test/ganeti.confd.client_unittest.py \
691         test/ganeti.config_unittest.py \
692         test/ganeti.constants_unittest.py \
693         test/ganeti.errors_unittest.py \
694         test/ganeti.hooks_unittest.py \
695         test/ganeti.ht_unittest.py \
696         test/ganeti.http_unittest.py \
697         test/ganeti.hypervisor_unittest.py \
698         test/ganeti.hypervisor.hv_chroot_unittest.py \
699         test/ganeti.hypervisor.hv_fake_unittest.py \
700         test/ganeti.hypervisor.hv_kvm_unittest.py \
701         test/ganeti.hypervisor.hv_lxc_unittest.py \
702         test/ganeti.hypervisor.hv_xen_unittest.py \
703         test/ganeti.impexpd_unittest.py \
704         test/ganeti.jqueue_unittest.py \
705         test/ganeti.locking_unittest.py \
706         test/ganeti.luxi_unittest.py \
707         test/ganeti.masterd.instance_unittest.py \
708         test/ganeti.mcpu_unittest.py \
709         test/ganeti.netutils_unittest.py \
710         test/ganeti.objects_unittest.py \
711         test/ganeti.opcodes_unittest.py \
712         test/ganeti.ovf_unittest.py \
713         test/ganeti.qlang_unittest.py \
714         test/ganeti.query_unittest.py \
715         test/ganeti.rapi.baserlib_unittest.py \
716         test/ganeti.rapi.client_unittest.py \
717         test/ganeti.rapi.resources_unittest.py \
718         test/ganeti.rapi.rlib2_unittest.py \
719         test/ganeti.rpc_unittest.py \
720         test/ganeti.runtime_unittest.py \
721         test/ganeti.serializer_unittest.py \
722         test/ganeti.ssh_unittest.py \
723         test/ganeti.tools.ensure_dirs_unittest.py \
724         test/ganeti.uidpool_unittest.py \
725         test/ganeti.utils.algo_unittest.py \
726         test/ganeti.utils.filelock_unittest.py \
727         test/ganeti.utils.hash_unittest.py \
728         test/ganeti.utils.io_unittest.py \
729         test/ganeti.utils.log_unittest.py \
730         test/ganeti.utils.mlock_unittest.py \
731         test/ganeti.utils.nodesetup_unittest.py \
732         test/ganeti.utils.process_unittest.py \
733         test/ganeti.utils.retry_unittest.py \
734         test/ganeti.utils.text_unittest.py \
735         test/ganeti.utils.wrapper_unittest.py \
736         test/ganeti.utils.x509_unittest.py \
737         test/ganeti.utils_unittest.py \
738         test/ganeti.workerpool_unittest.py \
739         test/cfgupgrade_unittest.py \
740         test/docs_unittest.py \
741         test/pycurl_reset_unittest.py \
742         test/tempfile_fork_unittest.py
743
744 haskell_tests = htools/test
745
746 dist_TESTS = \
747         test/check-cert-expired_unittest.bash \
748         test/daemon-util_unittest.bash \
749         test/ganeti-cleaner_unittest.bash \
750         test/import-export_unittest.bash \
751         $(python_tests)
752
753 nodist_TESTS =
754 if WANT_HTOOLSTESTS
755 nodist_TESTS += $(haskell_tests)
756 endif
757
758 TESTS = $(dist_TESTS) $(nodist_TESTS)
759
760 # Environment for all tests
761 PLAIN_TESTS_ENVIRONMENT = \
762         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
763
764 # Environment for tests run by automake
765 TESTS_ENVIRONMENT = \
766         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
767
768 all_python_code = \
769         $(dist_sbin_SCRIPTS) \
770         $(python_scripts) \
771         $(pkglib_python_scripts) \
772         $(nodist_pkglib_python_scripts) \
773         $(python_tests) \
774         $(pkgpython_PYTHON) \
775         $(client_PYTHON) \
776         $(hypervisor_PYTHON) \
777         $(rapi_PYTHON) \
778         $(server_PYTHON) \
779         $(pytools_PYTHON) \
780         $(http_PYTHON) \
781         $(confd_PYTHON) \
782         $(masterd_PYTHON) \
783         $(impexpd_PYTHON) \
784         $(utils_PYTHON) \
785         $(watcher_PYTHON) \
786         $(noinst_PYTHON) \
787         $(qa_scripts)
788
789 srclink_files = \
790         man/footer.rst \
791         test/check-cert-expired_unittest.bash \
792         test/daemon-util_unittest.bash \
793         test/ganeti-cleaner_unittest.bash \
794         test/import-export_unittest.bash \
795         $(all_python_code) \
796         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
797
798 check_python_code = \
799         $(BUILD_BASH_COMPLETION) \
800         $(CHECK_IMPORTS) \
801         $(CHECK_HEADER) \
802         $(DOCPP) \
803         $(all_python_code)
804
805 lint_python_code = \
806         ganeti \
807         ganeti/http/server.py \
808         $(dist_sbin_SCRIPTS) \
809         $(python_scripts) \
810         $(pkglib_python_scripts) \
811         $(BUILD_BASH_COMPLETION) \
812         $(CHECK_IMPORTS) \
813         $(CHECK_HEADER) \
814         $(DOCPP) \
815         $(PYTHON_BOOTSTRAP)
816
817 standalone_python_modules = \
818         lib/rapi/client.py \
819         tools/ganeti-listrunner
820
821 pep8_python_code = \
822         ganeti \
823         ganeti/http/server.py \
824         $(dist_sbin_SCRIPTS) \
825         $(python_scripts) \
826         $(pkglib_python_scripts) \
827         $(BUILD_BASH_COMPLETION) \
828         $(CHECK_HEADER) \
829         $(DOCPP) \
830         $(PYTHON_BOOTSTRAP) \
831         qa
832
833 test/daemon-util_unittest.bash: daemons/daemon-util
834
835 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
836
837 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
838         sed -f $(REPLACE_VARS_SED) < $< > $@
839         chmod +x $@
840
841 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
842         sed -f $(REPLACE_VARS_SED) < $< > $@
843         chmod u+x $@
844
845 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
846         sed -f $(REPLACE_VARS_SED) < $< > $@
847         chmod +x $@
848
849 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
850         sed -f $(REPLACE_VARS_SED) < $< > $@
851
852 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
853         sed -f $(REPLACE_VARS_SED) < $< > $@
854
855 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
856         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
857         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
858
859 doc/%.png: doc/%.dot
860         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
861         $(DOT) -Tpng -o $@ $<
862
863 man/footer.man: man/footer.rst
864         @test -n "$(PANDOC)" || \
865           { echo 'pandoc' not found during configure; exit 1; }
866         $(PANDOC) -f rst -t man -o $@ $<
867
868 man/footer.html: man/footer.rst
869         @test -n "$(PANDOC)" || \
870           { echo 'pandoc' not found during configure; exit 1; }
871         $(PANDOC) -f rst -t html -o $@ $<
872
873 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
874         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
875
876 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
877         @test -n "$(PANDOC)" || \
878           { echo 'pandoc' not found during configure; exit 1; }
879         set -o pipefail ; \
880         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
881           sed -e 's/\\@/@/g' > $@
882         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
883
884 man/%.html.in: man/%.gen man/footer.html
885         @test -n "$(PANDOC)" || \
886           { echo 'pandoc' not found during configure; exit 1; }
887         set -o pipefail ; \
888         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
889           sed -e 's/\\@/@/g' > $@
890
891 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
892         sed -f $(REPLACE_VARS_SED) < $< > $@
893
894 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
895         sed -f $(REPLACE_VARS_SED) < $< > $@
896
897 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
898         sed -f $(REPLACE_VARS_SED) < $< > $@
899
900 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
901         sed -f $(REPLACE_VARS_SED) < $< > $@
902
903 epydoc.conf: epydoc.conf.in Makefile
904         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
905
906 vcs-version:
907         if test -d .git; then \
908           git describe > $@; \
909         elif test ! -f $@ ; then \
910           echo "Cannot auto-generate $@ file"; exit 1; \
911         fi
912
913 .PHONY: regen-vcs-version
914 regen-vcs-version:
915         set -e; \
916         cd $(srcdir); \
917         if test -d .git; then \
918           rm -f vcs-version; \
919           $(MAKE) vcs-version; \
920         fi
921
922 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
923         set -e; \
924         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
925         sed -e "s/%ver%/$$VCSVER/" < $< > $@
926
927 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
928         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS) \
929         | lib/_vcsversion.py
930         set -e; \
931         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
932
933 lib/_autoconf.py: Makefile | lib/.dir
934         set -e; \
935         { echo '# This file is automatically generated, do not edit!'; \
936           echo '#'; \
937           echo ''; \
938           echo '"""Build-time configuration for Ganeti.'; \
939           echo '';\
940           echo 'This file is autogenerated by the build process.'; \
941           echo 'For any changes you need to re-run ./configure (and'; \
942           echo 'not edit by hand).'; \
943           echo ''; \
944           echo '"""'; \
945           echo ''; \
946           echo '# pylint: disable=C0301,C0324'; \
947           echo '# because this is autogenerated, we do not want'; \
948           echo '# style warnings' ; \
949           echo ''; \
950           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
951           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
952           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
953           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
954           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
955           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
956           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
957           echo "SYSCONFDIR = '$(sysconfdir)'"; \
958           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
959           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
960           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
961           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
962           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
963           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
964           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
965           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
966           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
967           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
968           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
969           echo "KVM_PATH = '$(KVM_PATH)'"; \
970           echo "IP_PATH = '$(IP_PATH)'"; \
971           echo "SOCAT_PATH = '$(SOCAT)'"; \
972           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
973           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
974           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
975           echo "TOOLSDIR = '$(toolsdir)'"; \
976           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
977           echo "PKGLIBDIR = '$(pkglibdir)'"; \
978           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
979           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
980           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
981           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
982           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
983           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
984           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
985           echo "RAPI_USER = '$(RAPI_USER)'"; \
986           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
987           echo "CONFD_USER = '$(CONFD_USER)'"; \
988           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
989           echo "NODED_USER = '$(NODED_USER)'"; \
990           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
991           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
992           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
993           if [ "$(HTOOLS)" ]; then \
994             echo "HTOOLS = True"; \
995           else \
996             echo "HTOOLS = False"; \
997           fi; \
998           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
999         } > $@
1000
1001 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1002         set -e; \
1003         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1004         { echo '# This file is automatically generated, do not edit!'; \
1005           echo '#'; \
1006           echo ''; \
1007           echo '"""Build-time VCS version number for Ganeti.'; \
1008           echo '';\
1009           echo 'This file is autogenerated by the build process.'; \
1010           echo 'For any changes you need to re-run ./configure (and'; \
1011           echo 'not edit by hand).'; \
1012           echo ''; \
1013           echo '"""'; \
1014           echo ''; \
1015           echo '# pylint: disable=C0301,C0324'; \
1016           echo '# because this is autogenerated, we do not want'; \
1017           echo '# style warnings' ; \
1018           echo ''; \
1019           echo "VCS_VERSION = '$$VCSVER'"; \
1020         } > $@
1021
1022 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC) | lib/.dir
1023         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) $< > $@
1024
1025 $(REPLACE_VARS_SED): Makefile
1026         set -e; \
1027         { echo 's#@PREFIX@#$(prefix)#g'; \
1028           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1029           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1030           echo 's#@BINDIR@#$(bindir)#g'; \
1031           echo 's#@SBINDIR@#$(sbindir)#g'; \
1032           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1033           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1034           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1035           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1036           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1037           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1038           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1039           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1040           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1041           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1042           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1043           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1044           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1045           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1046           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1047           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1048           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1049           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1050           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1051         } > $@
1052
1053 # Using deferred evaluation
1054 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1055 daemons/ganeti-watcher: MODULE = ganeti.watcher
1056 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1057 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1058
1059 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1060         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1061         set -e; \
1062         { echo '#!/usr/bin/python'; \
1063           echo '# This file is automatically generated, do not edit!'; \
1064           echo "# Edit $(MODULE) instead."; \
1065           echo; \
1066           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1067           echo; \
1068           echo '# pylint: disable=C0103'; \
1069           echo '# C0103: Invalid name'; \
1070           echo; \
1071           echo 'import sys'; \
1072           echo 'import $(MODULE) as main'; \
1073           echo; \
1074           echo '# Temporarily alias commands until bash completion'; \
1075           echo '# generator is changed'; \
1076           echo 'if hasattr(main, "commands"):'; \
1077           echo '  commands = main.commands # pylint: disable=E1101'; \
1078           echo 'if hasattr(main, "aliases"):'; \
1079           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1080           echo; \
1081           echo 'if __name__ == "__main__":'; \
1082           echo '  sys.exit(main.Main())'; \
1083         } > $@
1084         chmod u+x $@
1085
1086 # We need to create symlinks because "make distcheck" will not install Python
1087 # files when building.
1088 stamp-srclinks: Makefile | $(all_dirfiles)
1089         set -e; \
1090         for i in $(srclink_files); do \
1091                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1092                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1093                 fi; \
1094         done
1095         touch $@
1096
1097 .PHONY: ganeti
1098 ganeti:
1099         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1100
1101 .PHONY: check-dirs
1102 check-dirs: $(BUILT_SOURCES)
1103         @set -e; \
1104         find . -type d \( \( -name . \) -o \( \
1105                 -name .git -o \
1106                 -name autom4te.cache \
1107                 \) -prune -o -print \) | { \
1108                 error=; \
1109                 while read dir; do \
1110                         case "$$dir" in \
1111                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1112                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1113                         esac; \
1114                 done; \
1115                 for dir in $(DIRS); do \
1116                         if ! test -d "$$dir"; then \
1117                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1118                                 error=1; \
1119                         fi \
1120                 done; \
1121                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1122         }
1123
1124 .PHONY: check-local
1125 check-local: check-dirs $(BUILT_SOURCES)
1126         $(CHECK_PYTHON_CODE) $(check_python_code)
1127         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1128         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1129         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1130         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1131         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1132         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1133                 echo "Incorrect version in README, expected $$expver"; \
1134                 exit 1; \
1135         fi; \
1136         for file in doc/iallocator.rst doc/hooks.rst; do \
1137                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1138                         "Documents Ganeti version $$expver"; then \
1139                         echo "Incorrect version in $$file, expected $$expver"; \
1140                         exit 1; \
1141                 fi; \
1142         done
1143
1144 .PHONY: hs-check
1145 hs-check: htools/test
1146         @rm -f test.tix
1147         ./htools/test
1148
1149 # E111: indentation is not a multiple of four
1150 # E261: at least two spaces before inline comment
1151 # E501: line too long (80 characters)
1152 PEP8_IGNORE = E111,E261,E501
1153
1154 # For excluding pep8 expects filenames only, not whole paths
1155 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1156
1157 .PHONY: lint
1158 lint: $(BUILT_SOURCES)
1159         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1160         if test -z "$(PEP8)"; then \
1161                 echo '"pep8" not found during configure' >&2; \
1162         else \
1163                 $(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1164                         $(pep8_python_code); \
1165         fi
1166         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1167         cd $(top_srcdir)/qa && \
1168           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1169           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1170
1171 .PHONY: hlint
1172 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1173         if tty -s; then C="-c"; else C=""; fi; \
1174         hlint --report=doc/hs-lint.html --cross $$C \
1175           --ignore "Use first" \
1176           --ignore "Use comparing" \
1177           --ignore "Use on" \
1178           --ignore "Use Control.Exception.catch" \
1179           --ignore "Reduce duplication" \
1180           --hint htools/lint-hints \
1181           $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1182
1183 # a dist hook rule for updating the vcs-version file; this is
1184 # hardcoded due to where it needs to build the file...
1185 dist-hook:
1186         $(MAKE) regen-vcs-version && \
1187         rm -f $(top_distdir)/vcs-version && \
1188         cp -p $(srcdir)/vcs-version $(top_distdir)
1189
1190 # a distcheck hook rule for catching revision control directories
1191 distcheck-hook:
1192         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1193                 echo "Found revision control files in final archive." 1>&2; \
1194                 exit 1; \
1195         fi
1196         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1197                 echo "Found Python byte code in final archive." 1>&2; \
1198                 exit 1; \
1199         fi
1200         if find $(top_distdir) -name '*~' | grep .; then \
1201                 echo "Found backup files in final archive." 1>&2; \
1202                 exit 1; \
1203         fi
1204 # Empty files or directories should not be distributed. They can cause
1205 # unnecessary warnings for packagers. Directories used by automake during
1206 # distcheck must be excluded.
1207         if find $(top_distdir) -empty -and -not \( \
1208                         -path $(top_distdir)/_build -or \
1209                         -path $(top_distdir)/_inst \) | grep .; then \
1210                 echo "Found empty files or directories in final archive." 1>&2; \
1211                 exit 1; \
1212         fi
1213         if test -n "$(BUILD_RELEASE)" && \
1214            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1215                 echo "Found unreleased version in NEWS." >&2; \
1216                 exit 1; \
1217         fi
1218
1219 # When building a release, stricter checks should be used
1220 distcheck-release dist-release: export BUILD_RELEASE = 1
1221 distcheck-release: distcheck
1222
1223 dist-release: dist
1224         set -e; \
1225         for i in $(DIST_ARCHIVES); do \
1226                 echo -n "Checking $$i ... "; \
1227                 autotools/check-tar < $$i; \
1228                 echo OK; \
1229         done
1230
1231 install-exec-local:
1232         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1233           "$(DESTDIR)${localstatedir}/log/ganeti" \
1234           "$(DESTDIR)${localstatedir}/run/ganeti"
1235
1236 # To avoid conflicts between directory names and other targets, a file inside
1237 # the directory is used to ensure its existence.
1238 %.dir:
1239         @mkdir_p@ $* && touch $@
1240
1241 .PHONY: apidoc
1242 if WANT_HTOOLSAPIDOC
1243 apidoc: py-apidoc hs-apidoc
1244 else
1245 apidoc: py-apidoc
1246 endif
1247
1248 .PHONY: py-apidoc
1249 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1250         $(RUN_IN_TEMPDIR) epydoc -v \
1251                 --conf $(CURDIR)/epydoc.conf \
1252                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1253
1254 .PHONY: hs-apidoc
1255 hs-apidoc: $(HS_BUILT_SRCS)
1256         @test -n "$(HSCOLOUR)" || \
1257             { echo 'HsColour' not found during configure; exit 1; }
1258         @test -n "$(HADDOCK)" || \
1259             { echo 'haddock' not found during configure; exit 1; }
1260         rm -rf $(APIDOC_HS_DIR)/*
1261         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1262         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1263         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1264         set -e ; \
1265         cd htools; \
1266         if [ "$(HTOOLS_NOCURL)" ]; \
1267         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1268         else OPTGHC=""; \
1269         fi; \
1270         if [ "$(HTOOLS_PARALLEL3)" ]; \
1271         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1272         fi; \
1273         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1274         for file in $$RELSRCS; do \
1275                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1276                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1277         done ; \
1278         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1279                 -t ganeti-htools -p haddock-prologue \
1280                 --source-module="%{MODULE/.//}.html" \
1281                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1282                 $$OPTGHC \
1283                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1284
1285 .PHONY: TAGS
1286 TAGS: $(BUILT_SOURCES)
1287         rm -f TAGS
1288         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1289           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1290           -path './qa/*.py' | \
1291           etags -l python -
1292
1293 .PHONY: coverage
1294 if WANT_HTOOLS
1295 coverage: py-coverage hs-coverage
1296 else
1297 coverage: py-coverage
1298 endif
1299
1300 .PHONY: py-coverage
1301 py-coverage: $(BUILT_SOURCES) $(python_tests)
1302         set -e; \
1303         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1304         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1305         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1306         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1307         $(python_tests)
1308
1309 .PHONY: hs-coverage
1310 hs-coverage: $(haskell_tests)
1311         cd htools && rm -f *.tix *.mix && ./test
1312         @mkdir_p@ $(COVERAGE_HS_DIR)
1313         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1314         hpc report htools/test $(HPCEXCL)
1315         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1316
1317 # Special "kind-of-QA" target for htools, needs special setup (all
1318 # tools compiled with -fhpc)
1319 .PHONY: live-test
1320 live-test: all
1321         set -e ; \
1322         cd htools; \
1323         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1324         rm -f *.tix *.mix; \
1325         ./live-test.sh; \
1326         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1327           --output=live-test.tix ; \
1328         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1329         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1330                 --srcdir=.. $(HPCEXCL) ; \
1331         hpc report --srcdir=.. live-test $(HPCEXCL)
1332
1333 commit-check: distcheck lint apidoc
1334
1335 -include ./Makefile.local
1336
1337 # vim: set noet :